module("luci.model.cbi.bypass.kcptun",package.seeall)
local s=require"nixio.fs"
local o=require"luci.sys"
local a=require"luci.util"
local t=require"luci.i18n"
local e=require"luci.model.cbi.bypass.api"
local i="https://api.github.com/repos/xtaci/kcptun/releases/latest"
function to_check(a)
local o=e.get_kcptun_path()or""
if o==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","Kcptun")
}
end
if not a or a==""then a=e.auto_get_arch()end
local r,d=e.get_file_info(a)
if r==""then
return{
code=1,
error=t.translate("Can't determine ARCH, or ARCH not supported.")
}
end
local a=e.get_api_json(i)
if a.tag_name==nil then
return{
code=1,
error=t.translate("Get remote version info failed.")
}
end
local s=e.get_kcptun_version()
local n=a.tag_name:match("[^v]+")
local o=e.compare_versions(s,"<",n)
local h,i
if o then
h=a.html_url
for t,e in ipairs(a.assets)do
if e.name and e.name:match("linux%-"..r..d)then
i=e.browser_download_url
break
end
end
end
if o and not i then
return{
code=1,
now_version=s,
version=n,
html_url=h,
error=t.translate("New version found, but failed to get new version download url.")
}
end
return{
code=0,
update=o,
now_version=s,
version=n,
url={html=h,download=i}
}
end
function to_download(i)
local n=e.get_kcptun_path()or""
if n==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","Kcptun")
}
end
if not i or i==""then
return{code=1,error=t.translate("Download url is required.")}
end
o.call("/bin/rm -f /tmp/kcptun_download.*")
local a=a.trim(a.exec("mktemp -u -t kcptun_download.XXXXXX"))
local o=e.exec(e.curl,{e._unpack(e.curl_args),"-o",a,i},nil,e.command_timeout)==0
if not o then
e.exec("/bin/rm",{"-f",a})
return{
code=1,
error=t.translatef("File download failed or timed out: %s",i)
}
end
return{code=0,file=a}
end
function to_extract(i,h)
local n=e.get_kcptun_path()or""
if n==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","Kcptun")
}
end
if not i or i==""or not s.access(i)then
return{code=1,error=t.translate("File path required.")}
end
o.call("/bin/rm -rf /tmp/kcptun_extract.*")
local n=a.trim(a.exec("mktemp -d -t kcptun_extract.XXXXXX"))
local o={}
e.exec("/bin/tar",{"-C",n,"-zxvf",i},
function(e)o[#o+1]=e end)
local s=a.split(table.concat(o))
e.exec("/bin/rm",{"-f",i})
local o=nil
for t,e in pairs(s)do
if e:match("client_linux_%s"%h)then
o=n.."/"..a.trim(e)
break
end
end
if not o then
for t,e in pairs(s)do
if e:match("client_")then
o=n.."/"..a.trim(e)
break
end
end
end
if not o then
e.exec("/bin/rm",{"-rf",n})
return{
code=1,
error=t.translatef("Can't find client in file: %s",i)
}
end
return{code=0,file=o}
end
function to_move(n)
local a=e.get_kcptun_path()or""
if a==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","Kcptun")
}
end
if not n or n==""or not s.access(n)then
o.call("/bin/rm -rf /tmp/kcptun_extract.*")
return{code=1,error=t.translate("Client file is required.")}
end
local i=e.get_kcptun_version(n)
if i==""then
o.call("/bin/rm -rf /tmp/kcptun_extract.*")
return{
code=1,
error=t.translate("The client file is not suitable for current device.")
}
end
local i
if s.access(a)then
i=a..".bak"
e.exec("/bin/mv",{"-f",a,i})
end
local n=e.exec("/bin/mv",{"-f",n,a},nil,e.command_timeout)==0
if not n or not s.access(a)then
o.call("/bin/rm -rf /tmp/kcptun_extract.*")
if i then
e.exec("/bin/mv",{"-f",i,a})
end
return{
code=1,
error=t.translatef("Can't move new file to path: %s",a)
}
end
e.exec("/bin/chmod",{"755",a})
if i then e.exec("/bin/rm",{"-f",i})end
o.call("/bin/rm -rf /tmp/kcptun_extract.*")
return{code=0}
end
