module("luci.model.cbi.bypass.xray",package.seeall)
local d=require"nixio.fs"
local i=require"luci.sys"
local n=require"luci.util"
local t=require"luci.i18n"
local e=require"luci.model.cbi.bypass.api"
local o="https://api.github.com/repos/XTLS/Xray-core/releases?per_page=1"
local a=false
function to_check(a)
local i=e.get_xray_path()or""
if i==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","Xray")
}
end
if not a or a==""then a=e.auto_get_arch()end
local a,d=e.get_file_info(a)
if a==""then
return{
code=1,
error=t.translate("Can't determine ARCH, or ARCH not supported.")
}
end
if a=="amd64"then a="64"end
if a=="386"then a="32"end
if a=="mipsle"then a="mips32le"end
if a=="mips"then a="mips32"end
if a=="arm"then a="arm32"end
local o=e.get_api_json(o)
if#o>0 then
o=o[1]
end
if o.tag_name==nil then
return{
code=1,
error=t.translate("Get remote version info failed.")
}
end
local h=e.get_xray_version()
local s=o.tag_name
local n=e.compare_versions(h:match("[^v]+"),"<",s:match("[^v]+"))
local i,r
if n then
i=o.html_url
for t,e in ipairs(o.assets)do
if e.name and e.name:match("linux%-"..a..(d~=""and".+"..d or""))then
r=e.browser_download_url
break
end
end
end
if n and not r then
return{
code=1,
now_version=h,
version=s,
html_url=i,
error=t.translate("New version found, but failed to get new version download url.")
}
end
return{
code=0,
update=n,
now_version=h,
version=s,
url={html=i,download=r}
}
end
function to_download(a)
local o=e.get_xray_path()or""
if o==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","Xray")
}
end
if not a or a==""then
return{code=1,error=t.translate("Download url is required.")}
end
i.call("/bin/rm -f /tmp/xray_download.*")
local o=n.trim(n.exec("mktemp -u -t xray_download.XXXXXX"))
local i=e.exec(e.curl,{e._unpack(e.curl_args),"-o",o,a},nil,e.command_timeout)==0
if not i then
e.exec("/bin/rm",{"-f",o})
return{
code=1,
error=t.translatef("File download failed or timed out: %s",a)
}
end
return{code=0,file=o}
end
function to_extract(a,o)
local o=e.get_xray_path()or""
if o==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","Xray")
}
end
if not a or a==""or not d.access(a)then
return{code=1,error=t.translate("File path required.")}
end
if i.exec("echo -n $(opkg list-installed | grep -c unzip)")~="1"then
e.exec("/bin/rm",{"-f",a})
return{
code=1,
error=t.translate("Not installed unzip, Can't unzip!")
}
end
i.call("/bin/rm -rf /tmp/xray_extract.*")
local o=n.trim(n.exec("mktemp -d -t xray_extract.XXXXXX"))
local t={}
e.exec("/usr/bin/unzip",{"-o",a,"-d",o},
function(e)t[#t+1]=e end)
local t=n.split(table.concat(t))
e.exec("/bin/rm",{"-f",a})
return{code=0,file=o}
end
function to_move(o)
local a=e.get_xray_path()or""
if a==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","Xray")
}
end
if not o or o==""then
i.call("/bin/rm -rf /tmp/xray_extract.*")
return{code=1,error=t.translate("Client file is required.")}
end
i.call("/etc/init.d/bypass stop")
local n=nil
n=e.exec("/bin/mv",{"-f",o.."/xray",a},nil,e.command_timeout)==0
i.call("/bin/rm -rf /tmp/xray_extract.*")
if not n or not d.access(a)then
return{
code=1,
error=t.translatef("Can't move new file to path: %s",a)
}
end
e.chmod_755(a)
i.call("/etc/init.d/bypass restart >/dev/null 2>&1 &")
return{code=0}
end
